/*
 *name: MDialog.h
 *description: read $AXIS_ACT from OfficeLite
 *author: tilman jochems
 *(c)29/05/2010, mfj, rivesaltes
 */

#ifndef MDialogH
#define MDialogH

#define DEBUG 0                 //0: definitiv version
                                //1: work without office light

/* the following lines have to be in MDialog.dfm when DEBUG==0
   - ... we don't know how to make conditional compilation in the dfm...
  object Cross: TCrossCommand
    AutoConnect = True
    ConnectKind = ckRunningOrNew
  end

  //and this one in this file
  TCrossCommand *Cross;
*/

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ExtCtrls.hpp>
#include <winsock2.h>
#include "CrossCommEXE_OCX.h"
#include <OleServer.hpp>
#if DEBUG==1
# include "Debug.h"
#endif

typedef unsigned long ulong;

class TFMDialog : public TForm
{
__published:
        TPanel *PCross;
        TLabel *LA0;
        TLabel *Label1;
        TLabel *LA1;
        TLabel *Label3;
        TLabel *LA2;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *LA3;
        TLabel *Label8;
        TLabel *LA4;
        TLabel *Label10;
        TLabel *LA5;
        TLabel *LMessage;
        TPanel *PArm;
        TEdit *EAddress;
        TButton *BSet;
        TTimer *TMessage;
        TCrossCommand *Cross;
        void __fastcall FormHide(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall BSetClick(TObject *Sender);
        void __fastcall TMessageTimer(TObject *Sender);
        void __fastcall EAddressKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
private:
#if DEBUG==0
        LPDISPATCH Dispatch;
#else
        TCrossDebug *Cross;
#endif
        char Buf[128];                  //buffer for general use
        long Timeout;                   //timeout for reading
        WideString Position;            //position returned from rob
        bool   AddressOk;               //address of socket ok
        SOCKET Socket;                  //socket server side
        struct sockaddr_in Address;     //address
        TLabel *LA[6];                  //for visu
        void __fastcall IdleHandler(TObject* Sender,bool &Done);
public:
        void MessageWrite(AnsiString msg,bool warn=false);
        void FatalError(AnsiString msg);
        __fastcall TFMDialog(TComponent* Owner);
};

extern PACKAGE TFMDialog *FMDialog;
#endif
